de.caff.generics.function

## Interface VarShortOperator

- Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface VarShortOperator

  Primitive short operator with a variable number of arguments.

  Although this basically works for a variable short array via the `apply(short...)` method implementors have to implement the method `apply(ShortIndexable)` with a `ShortIndexable` argument. This is done to make this class generally more useful without the need to copy arrays.

  Since:
    November 03, 2020
  Author:
    Rammi

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default short` | `apply(short... values)` Apply this operator.
    `short` | `apply(ShortIndexable values)` Apply this operator.
    `static VarShortOperator` | `fromBinary(ShortOperator2 binaryOp, short startValue)` Create an variable args operator from applying a binary operator over and over.

- - ### Method Detail

    - #### apply

          default short apply(short... values)

      Apply this operator. This default method forwards execution to `apply(ShortIndexable)`.
      Parameters:
        `values` - arguments on which this operator is applied
      Returns:
        result of applying this operator to all arguments

    - #### apply

          short apply(@NotNull
                      ShortIndexable values)

      Apply this operator.
      Parameters:
        `values` - indexable providing the values on which this operator operates
      Returns:
        result of applying this operator to all values

    - #### fromBinary

          @NotNull
          static VarShortOperator fromBinary(@NotNull
                                                      ShortOperator2 binaryOp,
                                                      short startValue)

      Create an variable args operator from applying a binary operator over and over.

      Eg

           VarShortOperator maxOp = VarShortOperator.fromBinary((v1, v2) -> (short)Math.max(v1, v2), Short.MIN_VALUE);
           short max = maxOp.apply((short)1, (short)-7, (short)-13, (short)42);

      On each application the currently accumulated result becomes the left (first) argument of `binaryOp`, while the run value becomes the right (second).
      Parameters:
        `binaryOp` - binary operator
        `startValue` - start value (result of operator if no values are given)
      Returns:
        variable short argument operator which applies the given binary operator over and over